Attribute VB_Name = "ModuleGeneral"
Option Explicit

Declare Function GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpkeyname As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpfileName As String) As Long
Declare Function GetProfileString Lib "Kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpkeyname As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
Declare Function WriteProfileString Lib "Kernel32" (ByVal lpApplicationName As String, lpkeyname As Any, lpstring As Any) As Integer
Declare Function WritePrivateProfileStringA Lib "Kernel32" (ByVal lpApplicationName As String, ByVal lpkeyname As Any, ByVal lpstring As Any, ByVal lpfileName As String) As Long

Global Const PRGVERSION = "1,1"    ' Version pour mise  jour de la base
Global VERSION_ACTU As Single

Global Qt As Integer               ' Quote pour version ventuel d'Oracle

Global Const SDate = "/"
 
Global RepertoireBase As String    ' Rpertoire de la base de donnes
Global Con As New Connection       ' Connection au moteur ADO
Global Cmd As New Command          ' Commande pour le moteur ADO
Global RS As Recordset             ' Tableau resultat

Global retour As String
Global ret As Integer

Global RepertoireMaq As String
Global RepertoireDoc As String

' Fichier Excel Pour les Masters
Global FichierSelectionne As String


Global NumTournoi As Long

' info sur le Tournoi
Type InfoTournoi
    Nom As String
    Annee As String
    TypeTournoi As String
    TypeChampionnat As String
    Tables As String
    Coequipier As String
    NbCircuits As String
    ClassementAnnexe As String
    ClassementAutre As String
    SystemeNotation As String
    PointPilote As String
    PointEcurie As String
    Essais As String
    NbTables As Integer
End Type
Global Tournoi As InfoTournoi

Global Circuit() As String

Global SeanceEssai As Integer
Global OrdreEssais As Integer
Global CircuitSelectionne As String
Global flgModifEssais As Boolean
Global flgClassementEssais  As Boolean

' info sur le Pilote
Global NumPilote As String
Global FlgValidation As Boolean
Global FlgInscription As Boolean
Global FlgClassement As Boolean


Function MaJ_Version()
Dim i As Integer
Dim SQL As String
Dim sqlVersion As String

    If VERSION_ACTU = 1.1 Then
    ' calcul des points pour les curies
        For i = 1 To 1
            Select Case i
            Case 1
                SQL = "ALTER TABLE Ecurie ADD (Points numerique)"
            End Select
            Cmd.CommandText = SQL
            Set RS = Cmd.Execute
            If Err <> 0 Then
                    MsgBox Str(Err) & " " & Error$ & Chr(10) & SQL, 64, "Requte non passe"
                    Err = 0
            End If
        Next i
        VERSION_ACTU = 1.2
    End If

    ' Empeche les retours en arriere de version
    If CDbl(PRGVERSION) >= VERSION_ACTU Then
        sqlVersion = "UPDATE Parametre "
        sqlVersion = sqlVersion & "SET ParinfoN = " & Str(CDbl(PRGVERSION) * 100) & " / 100"
        sqlVersion = sqlVersion & " WHERE Parcode='VERSION' "
        sqlVersion = sqlVersion & " AND parNum = O "
        Cmd.CommandText = sqlVersion
        Set RS = Cmd.Execute
        If Err <> 0 Then
                MsgBox Str(Err) & " " & Error$ & Chr(10) & SQL, 64, "Requte non passe"
                Err = 0
        End If
    End If

End Function

Function NouvelEcran()
Dim Formulaire As Object

    For Each Formulaire In Forms
        If Formulaire.Name <> "frmGene" Then
            Unload Formulaire
        End If
    Next
    
End Function

Function OuvertureBase()
Dim BaseDonnee As String
Dim sqlBase As String

    ' lecture de la base dans FDTournoi.ini
    RepertoireBase = ""
    retour = Command$
    
    If Trim(retour) <> "" Then
        If InStr(Trim(retour), "/ini=") > 0 Then
            RepertoireBase = Mid(Trim(retour), 6) & "\"
        End If
    End If
    retour = String$(255, 0)
    ret = GetPrivateProfileString("Chemin", ByVal "Base", "", retour, 255, "TournoiFD.ini")
    If ret = 0 Then
        RepertoireBase = CurDir
    Else
        RepertoireBase = Mid(retour, 1, ret)
    End If

    On Error GoTo LoadError
    
LoadExit:
    Con.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & RepertoireBase & "\bdTournoiFD.mdb;Persist Security Info=False"
    
    ' Connection  la base de donne
    Con.Open

    ' Affectation des commandes  la connection active
    Cmd.ActiveConnection = Con
        
    ' gestion de la base de donne
    sqlBase = "SELECT ParInfoN "
    sqlBase = sqlBase & "FROM Parametre "
    sqlBase = sqlBase & "WHERE ParCode='VERSION' "
    sqlBase = sqlBase & "AND ParNum = 0 "
    Cmd.CommandText = sqlBase
    Set RS = Cmd.Execute
    VERSION_ACTU = CSng(RS!ParinfoN)
    If CSng(PRGVERSION) <> VERSION_ACTU Then
        frmGene.MousePointer = 11
        Call MaJ_Version
        frmGene.MousePointer = 0
    End If
    
    NumTournoi = 0
    FrmOuverture.Show vbModal

    Exit Function
    
' code rcupr sur un site
LoadError:
    
    'Gestionnaire d'erreur avanc, si votre base de donne est introuvable
    'renvoi l'erreur 3024 comme code.
    If Err = 3024 Then
        'Applique les proprits CommonDialog avant l'affichage.
        With frmGene.CdgBase
            .DialogTitle = "Impossible de localiser la Base de Donnes"
            .Filter = "DBase bdTournoiFD (*.mdb)|*.mdb"
            .InitDir = CurDir
            .FileName = ""
            .Flags = cdlOFNExplorer Or cdlOFNFileMustExist Or cdlOFNPathMustExist
            .ShowOpen
            'vrifier que filename n'est pas une chane vide
            If .FileName <> "" Then
                'Vrifier que la DBase ouverte est rellement bdTournoiFD.mdb
                If Right(UCase(.FileName), Len("bdTournoiFD.mdb")) = "BDTOURNOIFD.MDB" Then
                    Resume LoadExit
                End If
                Resume
            Else
                If .FileName = "" Then
                    MsgBox "Base de Donnes bdTournoiFD non dfinie, dmarrage de l'application impossible !", vbCritical, "Erreur de chargement"

                    End
                End If
                Unload frmGene
            End If
        End With
    ElseIf Err <> 0 Then ' Autres erreurs...
            MsgBox Error$ & " - " & Str$(Err) & vbCrLf & "Erreur non gnre par l'application.", vbExclamation, "Erreur fatale"
            End
    End If

End Function

Function triColonne(LvwAtrier As Object, Column As MSComctlLib.ColumnHeader)

    If Column.Index - 1 = LvwAtrier.SortKey Then
        If LvwAtrier.SortOrder = lvwAscending Then
            LvwAtrier.SortOrder = lvwDescending
        Else
            LvwAtrier.SortOrder = lvwAscending
        End If
    Else
        LvwAtrier.SortKey = Column.Index - 1
        LvwAtrier.SortOrder = lvwAscending
    End If
    LvwAtrier.Sorted = True
    
End Function
